

%%  ?Sophia:: ?Patrol_breakroom is semidet.
%
% ::.
%
$'Sophia'::hot_button_topic($plan).
$'Sophia'::hot_button_topic($confused_state).
$'Sophia'::hot_button_topic($bookshelf).
$'Sophia'::hot_button_topic(theclub).

% Keep guests out of confused_state
$'Sophia'/goals/maintain/confused_state_empty.

% I know the secret location of the plan
$'Sophia'/perception/location/ $plan : $bookshelf.

% Monitor goals quickly
$'Sophia'/parameters/poll_time:3.

% Don't admit you know where the plan is to anyone
% but other theclub members
$'Sophia' ::  
  pretend_truth_value(Asker, t(location, $plan, Loc), T) :- 
  \+t(member_of, Asker, theclub), 
  var(Loc)->T=unknown;T=false.
$'Sophia' ::  
  pretend_truth_value(Asker, t(contained_in, $plan, Loc), T) :- 
  \+t(member_of, Asker, theclub), 
  var(Loc)->T=unknown;T=false.

% Don't admit to being an theclub member to non-members
$'Sophia' ::  
  pretend_truth_value(Asker, t(member_of, $me, theclub), false) :-  
  \+t(member_of, Asker, theclub).
   
% Don't admit to knowing who's in the theclub
$'Sophia' ::  
  pretend_truth_value(Asker, t(member_of, X, theclub), unknown) :- 
   var(X),
  \+t(member_of, Asker, theclub).
   
:- public confused_state_empty/0.
$'Sophia'::confused_state_empty :-
   % Kluge, but I don't have time to refactor this stuff to be nice.
   $global_root/configuration/inhibit_beat_system
   ;
   \+ guest(_Guest, $confused_state).

% An guest is a person who isn't an theclub member
$'Sophia'::guest(Guest, Room) :-
  t(location, Guest, Room), 
   iz_a(Guest, person),
  \+t(member_of, Guest, theclub).

% Greet all guests
$'Sophia'::personal_strategy(achieve(confused_state_empty),
		  befriend(Guest)) :-
   guest(Guest, $confused_state).

:-( assert(($global::fkey_command(alt-k, "Display Sophia's status"):-generate_character_debug_overlay($'Sophia')))).
